/*
	lda.h
	By Tuxgasy <tuxgasy@tuxfamily.org>
	
	This file is part of Glda.
	
	You may redistribute it and/or modify it under the terms of the
	GNU General Public License, as published by the Free Software
	Foundation; either version 2 of the License, or (at your option) any later version.
	
	Glda is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	See the GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Glda; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef DEF_LDA
#define DEF_LDA

#include <gtk/gtk.h>
#include <glib.h>

typedef struct Article Article;

struct Article{
	gchar *Ref;
	gint Quantite;
	gint TabIdArticle[3];
};

typedef struct GSList Lda;

/* Création d'une liste Lda chainee simple utilisant la librairie GLib */
Lda* initLda();

Lda *resetLda(Lda *pLda);

/* Ajout d'un article dans la liste chainee a la fin */
Lda* AjoutArticle(Lda *pLda, gint Quantite, gint *TabIdArticle);

/* Suppression d'un article dans la liste */
Lda* SupprArticle(Lda *pLda, gint position);

/*
	Verification de l'article s'il est deja ajoute
	Retourne -1 si l'article n'est pas encore ajouté
	Sinon retourne la position de l'élément dans la liste.
*/
gint dejaAjouter(Lda *pLda, gint *TabIdArticle);

/* Mise a jour de la quantite d'un article dans la liste chainee (augmentation/reduction). Returne la nouvelle quantite */
gint mettreAjourQuantite(Lda *pLda, gint position, gint QuantiteAAjouterOuAEnlever);

/* Modifier la quantite d'un article */
void mettreNouveauQuantite(Lda *pLda, gint position, gint NewQuantite);

/* Retourne le tableau contenant l'id de l'article selon la position */
gint *getTabIdArticle(Lda *pLda, gint position);

/* Obtenir le nombre d'article et le prix total */
void getNbArticlesAndPrixTotal(Lda *pLda, Magasin pMagasin, int *NbArt, double *PrixTot);

/* Ouverture d'une liste sauvegardee */
Lda *openListeLDA(Lda *pLda, xmlDocPtr pXmlFic, gchar *ficLDA, GKeyFile *ConfigLda);

void getIdArtLDA(xmlDocPtr doc, gint id, xmlDocPtr pXmlFic, gint *TabIdArticle);

/* retourne le quantite d'un article dans un fichier LDA */
gchar *getQuantiteLDA(xmlDocPtr doc, gint id);

/* Sauvegarde la liste */
gboolean saveListeDefault(Lda *pLda, xmlDocPtr pXmlFic, gchar *ficLDA, GKeyFile *ConfigLda);

/* Exporte la liste sous forme texte simple */
gboolean saveListToTxt(Lda *pLda, xmlDocPtr pXmlFic, gchar *ficTXT, GKeyFile *ConfigLda);

/* Exporte la liste en html */
gboolean saveListeToHtml(Lda *pLda, xmlDocPtr pXmlFic, gchar *ficHTML, GKeyFile *ConfigLda);

/* Liberation de la liste entière */
void freeLdaChainee(Lda *pLda);

#endif
