/*
	magasin.h
	By Tuxgasy <tuxgasy@tuxfamily.org>
	
	This file is part of Glda.
	
	You may redistribute it and/or modify it under the terms of the
	GNU General Public License, as published by the Free Software
	Foundation; either version 2 of the License, or (at your option) any later version.
	
	Glda is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	See the GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Glda; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef DEF_MAGASIN
#define DEF_MAGASIN

#include <gtk/gtk.h>
#include <glib.h>

typedef xmlDocPtr Magasin;

/*
  Initialise la lecture le fichier XML avec DOM
  */
Magasin initMagasin(const gchar *fichierXML);

/*
  Parcours et affiche le contenu du fichier XML
  Cette fonction m'a servit de voir la structure du chemin XPath
  */
void show(xmlNodePtr node);

/* Retourne le nom des categories */
gchar *getCategoryById(Magasin pMagasin, gint Id);

gint getIdCategoryByRef(Magasin pMagasin, gchar *pRef);

gchar *getRefCategoryById(Magasin pMagasin, gint Id);

void addCategoryToMagasin(Magasin pMagasin, gchar *Name);

void removeCategoryToMagasin(Magasin pMagasin, gint idCat);

/* Retourne le nom des sous categories */
gchar *getSousCategoryByCategory(Magasin pMagasin, gint IdCat, gint IdSSCat);

/* */
void getIdSSCatByName(Magasin pMagasin, gchar *SearchNameSSCat, gint *IdCat, gint *IdSSCat);

gint getIdSSCategoryByRef(Magasin pMagasin, gint IdCat, gchar *pRef);

gchar *getRefSSCategoryById(Magasin pMagasin, gint IdCat, gint IdSSCat);

void addSSCategoryToMagasin(Magasin pMagasin, gint idCat, gchar *Name);

void removeSSCategoryToMagasin(Magasin pMagasin, gint idCat, gint idSSCat);

/* Retourne le nome des articles */
gchar *getArticleNameBySousCategory(Magasin pMagasin, gint IdCat, gint IdSSCat, gint IdArt);

gchar *getRefArt(Magasin pMagasin, gint IdCat, gint IdSSCat, gint IdArt);

gint getIdArticleByRef(Magasin pMagasin, gint IdCat, gint IdSSCat, gchar *pRef);

void addArticleToMagasin(Magasin pMagasin, gint idCat, gint idSSCat, gchar *Name, gchar *Prix);

void removeArticleToMagasin(Magasin pMagasin, gint idCat, gint idSSCat, gint idArt);

/* Retourne le prix des articles */
gchar *getArticlePriceBySousCategory(Magasin pMagasin, gint IdCat, gint IdSSCat, gint IdArt);

void modifyCategoryToMagasin(Magasin pMagasin, gchar *NewName, gint idCat);

void modifySSCategoryToMagasin(Magasin pMagasin, gchar *NewName, gint idCat, gint idSSCat);

void modifyArticleToMagasin(Magasin pMagasin, gchar *NewName, gchar *NewPrix, gint idCat, gint idSSCat, gint idArt);

void freeMagasin(Magasin pMagasin);

#endif
