/*
	main.h
	By Tuxgasy <tuxgasy@tuxfamily.org>
	
	This file is part of Glda.
	
	You may redistribute it and/or modify it under the terms of the
	GNU General Public License, as published by the Free Software
	Foundation; either version 2 of the License, or (at your option) any later version.
	
	Glda is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	See the GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Glda; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#ifndef DEF_MAIN
#define DEF_MAIN

#define VERSION_GLDA	"0.4.2"

#define DIR_USER_CONFIG		"/.glda"
#define FILE_USER_CONFIG	"/glda.conf"

#include <gtk/gtk.h>
#include <glib.h>

#include "magasin.h"
#include "lda.h"

/****************************************************************

	En-tete de "main.c"

****************************************************************/

typedef struct glda glda;

struct glda{
	/* Variable contenant la version de Glda */
	gchar version[5];
	
	/* Pointeur vers la config utilisateur */
	GKeyFile *pConfig;
	
	/* Pointeur vers la liste des articles */
	Magasin pMagasin;
	
	/* Pointeur vers la liste d'achat à faire */
	Lda *pLdaChainee;
	
	/* chemin du fichier d'enregistrement de la liste d'achat */
	gchar *fichierLDA;
	
	/* Widget du Fenetre principale */
	GtkWidget *pWindow;
	
	/* */
	GtkTreeStore *pListCat;
	GtkTreeSelection *selectCat;
	
	/* */
	GtkListStore *pListArt;
	GtkTreeSelection *selectArt;
	
	/* */
	GtkListStore *pLda;
	GtkTreeSelection *selectLda;
	
	/* */
	GtkWidget *pLabelNbArt;
	GtkWidget *pLabelPrixTot;
	
	/* Variable permettant de savoir si la liste d'achat a été sauvegardé ou pas */
	gboolean save;
};

/* Fonction d'initialisation d'une variable glda */
glda *initGlda(gchar *argv);

/* Fonction de libération de mémoire alloué lors de l'initialisation d'une variable glda */
void freeGlda(glda *pGlda);

/******************************************************************

	En-tete de "config.c"

******************************************************************/

/* Initialisation de la configuration */
GKeyFile *initConfig();

/*gchar *getUserLang(GKeyFile* ConfigLda);
gchar *getUserDevise(GKeyFile* ConfigLda);*/

/* Libération de la configuration */
void freeConfig(GKeyFile* ConfigLda);

#endif
