/*
	printInterface.c
	By Tuxgasy <tuxgasy@tuxfamily.org>
	
	This file is part of Glda.
	
	You may redistribute it and/or modify it under the terms of the
	GNU General Public License, as published by the Free Software
	Foundation; either version 2 of the License, or (at your option) any later version.
	
	Glda is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
	See the GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with Glda; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <libxml/tree.h>
#include <libxml/parser.h>
#include <libxml/xpath.h>
#include <glib.h>
#include <gtk/gtk.h>

#include "main.h"
#include "interface.h"

void create_pPrint(glda *pGlda){
	Print *pPrintData;
	GtkPrintOperation *operation;
	GtkPrintSettings *settings = NULL;
	GError *error = NULL;
	gint res;
	
	pPrintData = (Print*)malloc(sizeof(Print));
	pPrintData->pGlda = pGlda;
	
	pPrintData->filename = g_strdup_printf("/tmp/mesCourses.txt");
	saveListToTxt(pGlda->pLdaChainee, pGlda->pMagasin, pPrintData->filename, pGlda->pConfig);
	
	pPrintData->font_size = 10.0;
	
	operation = gtk_print_operation_new();
	
	if(settings != NULL)
		gtk_print_operation_set_print_settings(operation, settings);
	
	g_signal_connect(G_OBJECT(operation), "begin_print", G_CALLBACK(begin_print), (Print*)pPrintData);
	g_signal_connect(G_OBJECT(operation), "draw_page", G_CALLBACK(draw_page), (Print*)pPrintData);
	g_signal_connect(G_OBJECT(operation), "end_print", G_CALLBACK(end_print), (Print*)pPrintData);
	
	res = gtk_print_operation_run(operation, GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG,
						GTK_WINDOW(pGlda->pWindow), &error);
	
	if(res == GTK_PRINT_OPERATION_RESULT_APPLY){
		settings = g_object_ref(gtk_print_operation_get_print_settings(operation));
	}
	
	g_object_unref(operation);
	g_free(pPrintData->filename);
	free(pPrintData);
}
